# This script monitors the flow between specified source and sink,
# and calculates delay caused by the 802.11-link.
# Output is arrival time of packet [j] and the average delay of the last
# 10 packets.
# Torgeir Haukaas -NTNU- 2006
###################################################################
BEGIN {
	source=2;	# refers to ns node numbers
	ap=3;		# refers to ns node numbers
	sink=4;		# refers to ns node numbers
	limit=11000;	# limit calculation to the k first packets
	sample=40;	# step size for delay sampling (in nof pkts)
}
(/^\+/ && $3==source) || (/^r/ && $4==ap) || (/^r/ && $5==sink) {
	for(k=0;k<limit;k=k+sample) {
		if ( $1=="+" && $12==k ) starttime[k]=$2;
		if ( $1=="r" && $12==k ) aptime[k]=$2;
		if ( $1=="r" && $41==k ) stoptime[k]=$3;
	}

}

END {
#	for (idx in starttime) print idx, starttime[idx], aptime[idx], stoptime[idx];
	
	j=1;
	for(i=0;i<limit;i=i+20) {
		if(starttime[i]>0 && aptime[i]>0 && stoptime[i]>0){
			total_delay=stoptime[i]-starttime[i];
			wifi_delay=stoptime[i]-aptime[i];
			share[j]=wifi_delay/total_delay;
			if(j>5) {
				running_avg=(share[j-4]+share[j-3]+share[j-2]+share[j-1]+share[j])/5;
				print stoptime[i], running_avg;
			} else if(j>10) {
				running_avg=(share[j-9]+share[j-8]+share[j-7]+share[j-6]+share[j-5]+share[j-4]+share[j-3]+share[j-2]+share[j-1]+share[j])/10;
				print stoptime[i], running_avg;
			} else print stoptime[i], share[j];
			j++;
			#printf("id %i start %f ap %f stop %f share %f\n", i, starttime[i], aptime[i], stoptime[i], share);
		}
	}
}