#!/bin/bash
# Torgeir Haukaas - NTNU 2006
# This script executes i iterations of a ns-simulation to make 
# a.........
#############################################################################
#
type=udp_zoom
type2=udp
UDP=1
TFRC=0
FTP=0
WEB=0
VIDEO=3xCoastguard_qcif
POB=250
folder=/home/torgeir/devel/master/case2/$type
dev=4
pathloss=2
dist=125
#i=$((FTP+UDP+WEB+TFRC-1))
#rm -f $folder/psnr-all.$type.txt
for ((  i=95 ;  i<=$dist;  i=i+3  ));
do
	echo "---->NEW ITERATION: pathloss=$pathloss deviation=$dev nodeDist=$i/10 -nofUDP $UDP -nofTFRC $TFRC <-------"
	mkdir $folder/nsout.$i
	ns 802.11.tcl -nofUDP $UDP -nofTFRC $TFRC -nofFTP $FTP -nofWEB $WEB -doPing 1 -pathlossExp $pathloss -std_db $dev -nodeDist $i > $folder/nsout.$i/std_out.$type.iteration$i.txt 2>&1
	echo "ns finished"
	et_ra nsout/sd_be.$type2.0 nsout/rd_be.$type2.0 nsin/st_$VIDEO.yuv_Q2.txt nsout/video2.dat videoVariants/$VIDEO.yuv_Q 2 31 nsout/frame_size.dat $VIDEO.m4v 01 $POB
	echo "et_ra finished, $VIDEO.m4v created "
	mp4creator -r 30 -c $VIDEO.m4v $folder/nsout.$i/$VIDEO.$i.mp4 > mp4creatorOut/out.$i.txt 2>&1
	echo "mp4creator finished, $VIDEO.$i.mp4 created"
	rm $VIDEO.m4v
	ffmpeg -i $folder/nsout.$i/$VIDEO.$i.mp4 -r 30 $folder/nsout.$i/$VIDEO.reconstructed.yuv > ffmpegOut/out.$i.txt 2>&1
	echo "ffmpeg finished, $VIDEO.reconstructed.yuv created "
	echo ""
	fixyuv nsout/sd_be.$type2.0 nsout/rd_be.$type2.0 new_st.txt $folder/nsout.$i/$VIDEO.reconstructed.yuv $folder/nsout.$i/$VIDEO.reconstructed.fixed.$i.yuv $POB > fixyuvOut/out.$i.txt 2>&1
	echo "fixyuv_ra finished "
	echo ""
	rm -f $folder/nsout.$i/$VIDEO.reconstructed.yuv
	psnr 176 144 420 $VIDEO.yuv $folder/nsout.$i/$VIDEO.reconstructed.fixed.$i.yuv > $folder/nsout.$i/psnr_$VIDEO.$type.it$i.txt 2>$folder/nsout.$i/psnr_result.$type.$i.txt
	echo "psnr finished "
	awk '{if ($8=="") print '$i'" " 0; else print '$i'" " $8}' $folder/nsout.$i/psnr_result.$type.$i.txt >>$folder/psnr_all.$type.txt

	cp nsout/rd_be.$type2.0 $folder/nsout.$i/rd_be.$type2.0
	cp nsout/sd_be.$type2.0 $folder/nsout.$i/sd_be.$type2.0
	cp nsout/802.11.tr $folder/nsout.$i/802.11.tr
	cp nsout/bwt.* $folder/nsout.$i/
	./xgr2.sh
	#echo "Press Y to clean N to keep tmp-files:"
	#read answer
	#if (( (($answer == Y)) || (($answer == y)) )); then
	#	./clean.sh
	#else
	#	echo "keeping tmp-files"
	#fi
done
cd $folder
xgraph psnr_all.$type.txt -nb -geometry 800x400 -bg white -t "Peak Signal-to-Noise Ratio" -y "PSNR (dB)" -x "Distance (m)" &

exit 0
