#!/bin/bash
# Torgeir Haukaas - NTNU 2006
# This script executes i iterations of a ns-simulation to make
# a presentation of 802.11 link delay (in %) for different input rates.
#############################################################################
#
type=udp
UDP=6
TFRC=0
FTP=0
WEB=0
VIDEO=3xCoastguard_qcif
POB=250
folder=/home/torgeir/devel/master/case4/many-udps

#i=$((FTP+UDP+WEB+TFRC-1))
#rm -f $folder/psnr-all.$type.txt
for ((  i=1 ;  i<=$UDP;  i++  ));
do
	echo "---->NEW ITERATION: -nofUDP $i <-------"
	mkdir $folder/nsout.$i
	ns 802.11.tcl -nofUDP $i -doPing 1 -disableRTS_CTS 1 -core_prop 46ms > $folder/nsout.$i/std_out.$type.iteration$i.txt 2>&1
	echo "ns finished"
	awk -f awk/added-delay.awk nsout/802.11.tr > nsout/one-udp-delay.$i.txt
	echo "added-delay.awk finished"
	awk -f awk/avg-delay.awk nofudp=$i nsout/one-udp-delay.$i.txt >> $folder/avg-delay.txt
	echo "avg-delay.awk finished"

	cp nsout/* $folder/nsout.$i/
	#./xgr2.sh

done
cd $folder
xgraph avg-delay.txt -nb -geometry 800x400 -bg white -t "802.11 link delay (share of total)" -y "Avg. Delay (%)" -x "UDP sources" &

exit 0
