# Awk script to find the throuput to a given destination node.
# Used to monitor web-traffic throughput.
# Input:
#	dn = destination node
# Torgeir Haukaas -NTNU- 2006 
# (Based on script by Lloyd Wood, University of Surrey)
###################################################################
BEGIN {
	highest_packet_id = 0;
	n = 1;
	st=0.5;
	web_flow_id=2;
}

/-Hs/ && /r/ {
	time = $3;
	node_1 = $5;
	node_2 = $7;
	bytes = $37;
	flow_number = $39;

	# The following while-loop ensures that empty time samples are taken
	# care of.
	while (time > st*n) {
		bps[n] = acc_byte[n]*8/(st*1000000);
		n++;
	}

	# Accumulate all received bytes at final destination for the flow of interest
	if (node_1 == dn && flow_number == web_flow_id)
		acc_byte[n] += bytes;
}

# End up with printing out the results	
END {
	for ( t = 1; t <= n; t++ ) {
		printf("%f %f\n", t*st, bps[t]);
	}
}
